/****************************************************************	
* Name : Atul Nayak						*
* flutter.cxx : Header file of class flutter			*
****************************************************************/	     
/*FLUTTER : Flutter is a butterfly which is hiding behind some doors
          	in the maze. When you come within a distance of 10 feet
		of flutter it starts moving in a predetermined path and 
		eventually takes you to a teleporter which leads to a world
		where there are many orbs. You have to follow flutter.*/

class flutter
{

	private:
		
		// number of polygons that make a flutter	
		int noOfPolygons;

		// the color of the flutter		
		GLfloat colors[3];

		// vector of number of vertices in each polygon		
		vector<int> noOfVertices;

		// the normal for all the vertices for a polygon
		vector<GLfloat> normals;

		// vertices in each polygon	
		vector<GLfloat> vertices;

		// the X position of the flutter in the Maze array at start	
		int positionX;

		// the Y position of the flutter in the Maze array at start	
		int positionY;
		
		// the next x position of flutter in the Maze array as per the
		// path
		int nextX;

		// the next y position of flutter in the Maze array as per the
		// path
		int nextY;

		// the position of the flutter object along the z axis
		float nextZ;

		// counter variable to track the path coordinate
		int ctr;
		
		// flag to indicate if the object is drawn for the first time
		int notFirstTime;

		// flag to indicate that the flutter object should go up
		int goUp;

		// flag to indicate that the flutter object should go down
		int goDown;

		// can be 0, 1 or 2
		int flutterNo;

	public:

		
		// constructor - reads the flutter.txt file
		flutter();

		// draw Flutter at the specified position 
		void drawFlutter(int x, int y, int);

		// return positionX
		int getPositionX();

		// return positionY
		int getPositionY();
		
		// return nextX
		int getNextX();

		// return nextY
		int getNextY();

		// makes flutter travel a predetermined path
		void moveFlutter();

		// set notFirstTime flag
		void setNotFirstTime();	

		// destructor
		~flutter();

};
