//Atul Nayak
//class otto methods

#include "common.hxx"
#include "otto.hxx"

// constructor
otto::otto()
{
	angle = 45.0;
	radius = 1.0;
	slices = 20;
	stacks = 20;
	
	z = 5.0;
	currX = x - radius;
	currY = y + radius;
}

// initialise directions and give a position to otto
void otto::init(int xPosition, int yPosition)
{
	x = xPosition*5 + 2.5;
	y = yPosition*5 + 2.5;
	goLeft = TRUE;
	goRight = FALSE;
	goUp = TRUE;
	goDown = FALSE;

}

// draw otto
void otto::drawOtto()
{
	glPushMatrix();
		GLfloat mat_diffuse[] = {1.0, 0.5, 1.0, 1.0};
		glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);	
		glTranslatef(x,y,z);
		glutSolidSphere(radius,slices, stacks);
	glPopMatrix();
}
	
// move otto depending on which flag was set
void otto::moveOtto()
{

	if (goRight)
	{
		x+= 0.5;
		currX = x + radius;
		nextX = currX + 0.5;
	}
	if (goLeft)
	{
		x-= 0.5;
		currX = x - radius;
		nextX = currX - 0.5;
	}
	if (goDown)
	{
		y-= 0.5;
		currY = y - radius;
		nextY = currY - 0.5;
	}
	if (goUp)
	{
		y+= 0.5;
		currY = y + radius;
		nextY = currY + 0.5;
	}
	z = 5.0;
}

float otto::getCurrX()
{
	return currX;
}

float otto::getCurrY()
{
	return currY;
}

float otto::getNextX()
{
	return nextX;
}

float otto::getNextY()
{
	return nextY;
}

float otto::getRadius()
{
	return radius;
}

void otto::reverseOtto(float value)
{
	angle += 45;
	if (angle >= 360)
		angle = 0;
}

void otto::checkNextX(float leftEdge, float rightEdge)
{
	if (((nextX + radius ) > leftEdge - radius) && (goRight == TRUE))
	{
		goRight = FALSE;
		goLeft = TRUE;
	}

	// check collisions with the left edge
	if (((nextX - radius ) < rightEdge + radius) && (goLeft == TRUE))
	{
		goRight = TRUE;
		goLeft = FALSE;
	}

}	

void otto::checkNextY(float topEdge, float bottomEdge)
{
	// check collision with bottom edge
	if (((nextY + radius) > bottomEdge - radius) && (goUp == TRUE))
	{
		goDown = TRUE;
		goUp = FALSE;
	}
	
	// check collision with top edge
	if (((nextY - radius) < topEdge + radius) && (goDown == TRUE))
	{
		goDown = FALSE;
		goUp = TRUE;
	}
}

void otto::checkNextXY(float leftEdge, float rightEdge, float topEdge, float bottomEdge)
{
	if (((nextX + radius ) > leftEdge - radius) && (goRight == TRUE))
	{
		goRight = FALSE;
		goLeft = TRUE;
	}
	else
	// check collisions with the left edge
	if (((nextX - radius ) < rightEdge + radius) && (goLeft == TRUE))
	{
		goRight = TRUE;
		goLeft = FALSE;
	}
	else
	// check collision with bottom edge
	if (((nextY + radius) > bottomEdge - radius) && (goUp == TRUE))
	{
		goDown = TRUE;
		goUp = FALSE;
	}
	else
	// check collision with top edge
	if (((nextY - radius) < topEdge + radius) && (goDown == TRUE))
	{
		goDown = FALSE;
		goUp = TRUE;
	}
}

void otto::setGoUp()
{
	goUp = TRUE;
	goDown = FALSE;
}

void otto::setGoDown()
{
	goUp = FALSE;
	goDown = TRUE;
}
	
void otto::setGoLeft()
{
	goLeft = TRUE;
	goRight = FALSE;
}

void otto::setGoRight()
{
	goLeft = FALSE;
	goRight = TRUE;
}


// set zorroTaken
void otto::setZorroTaken()
{
	zorroTaken = TRUE;
}

// reset zorroTaken
void otto::resetZorroTaken()
{
	zorroTaken = FALSE;
}


// return zorroTaken
int otto::getZorroTaken()
{
	return zorroTaken;
}
