/********************************************************
*	Name : Atul Nayak				*
*	tele.hxx : Header file for the teleporter	*
********************************************************/	
class teleporter
{

	private:

		// number of polygons that make a teleporter
		int noOfPolygons;

		// the color of the teleporter		
		GLfloat colors[3];		

		// vector of number of vertices in each polygon
		vector<int> noOfVertices;	

		// the normal for all the vertices for a polygon
		vector<GLfloat> normals;

		// vertices in each polygon
		vector<GLfloat> vertices;	

		// the number assigned to the teleporter
		char number;
	
		// the X position of the teleporter in the maze
		int positionX;

		// the Y position of the teleporter in the maze			
		int positionY;

		// the teleporter's  angle of rotation				
		float angle;			

	
	public:
		// constructor 
		teleporter();	

		// draw the teleporter at the location specified by x and y		
		void drawTeleporter(int x, int y);	

		// get the x position
		int getPositionX();

		// get the y position
		int getPositionY();

		// set the number of the teleporter
		void setTeleNo(char);

		// return number
		char getTeleNo();
		
		// if the teleporter is within 10 feet make the teleporter bright	
		void brightestColor();

		// if the teleporter is 110 feet away darken it
		void darkestColor();

		// change the color of the teleporter in proportion to the distance from the viewer
		void changeColor(float);

		// destructor
		~teleporter();

};
