/********************************************************
* Name  : Atul Nayak					*
* viewer.hxx : class viewer				*
* This is a class for the camera 			*
********************************************************/
class viewer
{

	private:
		// the X position of the camera location
		float eyesX;
		
		// the Y position of the camera location			
		float eyesY;

		// the Z position of the camera location
		float eyesZ;

		// the X position of the location the camera sees
		float seeX;

		// the Y position of the location the camera sees
		float seeY;

		// the Z position of the location the camera sees
		float seeZ;

		// the X position of the camera in the Maze array at start
		int positionX;

		// the Y position of the camera in the Maze array at start
		int positionY;

		// the X position of the camera in the Maze array at any instant
		int currentPositionX;

		// the Y position of the camera in the Maze array at any instant
		int currentPositionY;

		// the X position of the camera in the Maze array at next instant
		int nextPositionX;

		// the Y position of the camera in the Maze array at next instant
		int nextPositionY;

		// the current X position of the camera in the 3D Maze
		float currentEyesX;

		// the current Y position of the camera in the 3D Maze
		float currentEyesY;

		// the next X position of the camera in the 3D Maze
		float nextEyesX;

		// the next Y position of the camera in the 3D Maze
		float nextEyesY;

		// the angle of the camera
		float angle;

		// indicates if zorro should be drawn with the user
		int drawZorro;
	public:
		
		// Initialize the camera 
		void initialize(int, int);

		// return eyesX
		float getEyesX();

		// return eyesY
		float getEyesY();

		// return eyesZ
		float getEyesZ();
		
		// return seeX
		float getSeeX();

		// return seeY
		float getSeeY();

		// return seeZ
		float getSeeZ();
		
		// turn the camera to the left
		void turnLeft();

		// turn the camera to the right
		void turnRight();

		// move the camera forward
		void moveForward();
		
		// return currentPositionX
		int getCurrentPositionX();

		// return currentPositionY		
		int getCurrentPositionY();

		// return nextPositionX
		int getNextPositionX();

		// return nextPositionY
		int getNextPositionY();

		// return currentEyesX
		float getCurrentEyesX();

		// return currentEyesY
		float getCurrentEyesY();

		// return nextEyesX
		float getNextEyesX();

		// return nextEyesY
		float getNextEyesY();

		// move to the next X and old Y position
		void newXoldY();

		// move to the old X and new Y position
		void oldXnewY();

		// move back to the old X and old Y position
		void oldXoldY();

		// change the position of the camera to the values specified
		void changeEyes(int, int);

		// decide where the camera is positioned and where it is looking at 
		void lookAt();

		// change the camera's position to see the maze from the top
		void lookFromTop();

		// draw the user's representation from the top;
		void drawPlayer();

		// set drawZorro
		void setDrawZorro();
};
